'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _desc, _value, _class, _init, _class2, _temp;

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

var _jsBeautify = require('js-beautify');

var _jsBeautify2 = _interopRequireDefault(_jsBeautify);

var _fastDiff = require('fast-diff');

var _fastDiff2 = _interopRequireDefault(_fastDiff);

var _globPromise = require('glob-promise');

var _globPromise2 = _interopRequireDefault(_globPromise);

var _pMap = require('p-map');

var _pMap2 = _interopRequireDefault(_pMap);

var _grayMatter = require('gray-matter');

var _grayMatter2 = _interopRequireDefault(_grayMatter);

var _lodash = require('lodash.zipobject');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.uniq');

var _lodash4 = _interopRequireDefault(_lodash3);

var _pkgDir = require('pkg-dir');

var _pkgDir2 = _interopRequireDefault(_pkgDir);

var _toml = require('toml');

var _toml2 = _interopRequireDefault(_toml);

var _aru = require('aru');

var _aru2 = _interopRequireDefault(_aru);

var _coreDecorators = require('core-decorators');

var _compiler = require('./compiler');

var _compiler2 = _interopRequireDefault(_compiler);

var _section = require('./section');

var _section2 = _interopRequireDefault(_section);

var _server = require('./server');

var _server2 = _interopRequireDefault(_server);

var _view = require('./view');

var _view2 = _interopRequireDefault(_view);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// ¯\_(ツ)_/¯
let Yosuga = (_class = (_temp = _class2 = class Yosuga {

  /**
   * Directory paths
   * @prop lib Dirname for nuxt/lib
   * @prop data Filename for nuxt/lib/data.json
   * @prop opts Filename for nuxt/lib/opts.json
   * @prop style Dirname for nuxt/static/yosuga.css
   */


  /**
   * Option for Yosuga
   */


  /**
   * Server used for development
   */
  _validate(opts) {
    const str = _flowRuntime2.default.string();
    const num = _flowRuntime2.default.number();

    _flowRuntime2.default.object(_flowRuntime2.default.property('icon', str, true), _flowRuntime2.default.property('name', str, true), _flowRuntime2.default.property('port', num, true), _flowRuntime2.default.property('main', _flowRuntime2.default.union(_flowRuntime2.default.string('css'), _flowRuntime2.default.string('postcss'), _flowRuntime2.default.string('sass'), _flowRuntime2.default.string('less'), _flowRuntime2.default.string('stylus'))), _flowRuntime2.default.property('dirs', _flowRuntime2.default.object(_flowRuntime2.default.property('yosuga', str, true), _flowRuntime2.default.property('postcss', str, true), _flowRuntime2.default.property('sass', str, true), _flowRuntime2.default.property('less', str, true), _flowRuntime2.default.property('stylus', str, true)), true), _flowRuntime2.default.property('style', _flowRuntime2.default.object(_flowRuntime2.default.property('fontSize', str, true), _flowRuntime2.default.property('accentColor', str, true)), true)).assert(opts);
  }

  /**
   * Yosuga's default options
   */


  /**
   * Theme builder using Postcss
   */
  // $css: any;

  /**
   * Whether the server is built
   */


  /**
   * Mainly Nuxt
   */


  constructor(opts = Yosuga.defaultOpts) {
    this._validate(opts);

    this.sections = [];
    this.view = new _view2.default(opts);
    this.opts = _extends({}, Yosuga.defaultOpts, opts);
    this.opts.style = _extends({}, Yosuga.defaultOpts.style, opts.style || {});
    this._filepath = {
      lib: _path2.default.join(__dirname, '../lib/view/lib/'),
      data: _path2.default.join(__dirname, '../lib/view/lib/data.json'),
      opts: _path2.default.join(__dirname, '../lib/view/lib/opts.json'),
      style: _path2.default.join(__dirname, '../lib/view/static/yosuga.css')
    };
  }

  _reset() {
    var _this = this;

    return _asyncToGenerator(function* () {
      if (_this.opts.icon) {
        const iconname = _path2.default.join(__dirname, '../lib/view/static', _this.opts.icon);
        if (yield _fsExtra2.default.pathExists(iconname)) {
          yield _fsExtra2.default.remove(iconname);
        }
      }

      if (yield _fsExtra2.default.pathExists(_this._filepath.data)) {
        yield _fsExtra2.default.remove(_this._filepath.data);
      }

      if (yield _fsExtra2.default.pathExists(_this._filepath.opts)) {
        yield _fsExtra2.default.remove(_this._filepath.opts);
      }
    })();
  }

  /**
   * Determine whether the target tool exists directory
   */
  _getTargets() {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      const result = [];
      if (yield _fsExtra2.default.pathExists(_path2.default.resolve(_this2.opts.base, _this2.opts.dirs.css))) {
        result.push('css');
      }
      if (yield _fsExtra2.default.pathExists(_path2.default.resolve(_this2.opts.base, _this2.opts.dirs.postcss))) {
        result.push('postcss');
      }
      if (yield _fsExtra2.default.pathExists(_path2.default.resolve(_this2.opts.base, _this2.opts.dirs.sass))) {
        result.push('sass');
      }
      if (yield _fsExtra2.default.pathExists(_path2.default.resolve(_this2.opts.base, _this2.opts.dirs.less))) {
        result.push('less');
      }
      if (yield _fsExtra2.default.pathExists(_path2.default.resolve(_this2.opts.base, _this2.opts.dirs.stylus))) {
        result.push('stylus');
      }

      return result;
    })();
  }

  _getTargetContents(compiler, targets) {
    var _this3 = this;

    return _asyncToGenerator(function* () {
      const items = yield (0, _pMap2.default)(targets, (() => {
        var _ref = _asyncToGenerator(function* (target) {
          const targetDirname = _path2.default.resolve(_this3.opts.base, target);

          const pattern = _path2.default.join(targetDirname, '**/*.*');
          const comparisonPattern = _path2.default.join(targetDirname, '**/*.yosuga.*');
          const filenames = (yield (0, _globPromise2.default)(pattern)).filter(function (filename) {
            return !filename.includes('.yosuga.');
          });
          const comparisonFilenames = yield (0, _globPromise2.default)(comparisonPattern);
          const basenames = filenames.map(function (filename) {
            const extname = _path2.default.extname(filename);
            return _path2.default.basename(filename, extname);
          });

          const contents = yield (0, _pMap2.default)(filenames, (() => {
            var _ref2 = _asyncToGenerator(function* (filename) {
              const code = yield _fsExtra2.default.readFile(filename, 'utf-8');
              let css = code;
              if (_path2.default.extname(filename) === '.css') {
                css = yield compiler.standardize(code);
              }
              return {
                code,
                comparison: { css }
              };
            });

            return function (_x2) {
              return _ref2.apply(this, arguments);
            };
          })());
          const map = (0, _lodash2.default)(basenames, contents);

          yield (0, _pMap2.default)(comparisonFilenames, (() => {
            var _ref3 = _asyncToGenerator(function* (filename) {
              const extname = _path2.default.extname(filename);
              const key = _path2.default.basename(filename, `.yosuga${extname}`);
              const code = yield _fsExtra2.default.readFile(filename.replace('.yosuga', ''), 'utf-8');
              const altCode = yield _fsExtra2.default.readFile(filename, 'utf-8');
              map[key].altCode = altCode;
              map[key].comparison = yield compiler[extname](filename, altCode, 'output.css', code);

              // eslint-disable-next-line no-warning-comments
              // TODO: sourcemap merge
              map[key].comparison.css = yield compiler.standardize(map[key].comparison.css);
            });

            return function (_x3) {
              return _ref3.apply(this, arguments);
            };
          })());

          return map;
        });

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      })());

      const readyState = (0, _lodash2.default)(targets, items);
      // section names
      // e.g.) [ 'button', 'card', 'nav', 'table' ]
      const targetSectionKeys = Object.keys(readyState[_this3.opts.main]);

      const result = targetSectionKeys.every(function (key) {
        const items = _this3._getComparisonBy(readyState, key);
        const valid = _this3._diff(items, key);
        if (!valid) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = Object.values(readyState)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              const content = _step.value;

              delete content[key];
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        }
        return valid;
      });

      if (!result) {
        throw new Error(_chalk2.default.red('ERR! There are sections where each is not equal'));
      }

      return readyState;
    })();
  }

  _getComparisonBy(map, key) {
    const groups = Object.entries(map);
    return groups.map(([target, items]) => {
      const comparison = (items[key] || {}).comparison;
      if (comparison === undefined) {
        return undefined;
      }

      comparison.target = target;
      return comparison;
    }).filter(comparison => comparison);
  }

  _diff(comparisonItems, key) {
    const baseItem = comparisonItems[0];

    return comparisonItems.slice(1).every(item => {
      const diffed = (0, _fastDiff2.default)(baseItem.css, item.css);

      if (diffed.length === 1) {
        return true;
      }

      const result = diffed.map(chunks => {
        switch (chunks[0]) {
          case -1:
            {
              return _chalk2.default.green(chunks[1]);
            }
          case 0:
          default:
            {
              return chunks[1];
            }
          case 1:
            {
              return _chalk2.default.red(chunks[1]);
            }
        }
      }).join('');

      if (process.env.NODE_ENV !== 'test') {
        console.log(_chalk2.default.bold(`${_chalk2.default.yellow('`' + key + '`')} is missing`));
        console.log(_chalk2.default.bold(`${_chalk2.default.gray(' - ')}${_chalk2.default.green(baseItem.target)}${_chalk2.default.gray(' / ')}${_chalk2.default.red(item.target)}`));
        console.log();
        console.log(result);
        console.log();
        console.log();
        console.log();
      }
      return false;
    });
  }

  _getSections(basenames) {
    var _this4 = this;

    return _asyncToGenerator(function* () {
      // eslint-disable-next-line no-return-await
      return yield (0, _pMap2.default)(basenames, (() => {
        var _ref4 = _asyncToGenerator(function* (name) {
          const filePattern = _path2.default.join(_this4.opts.base, _this4.opts.dirs.yosuga, `${name}.html`);

          var _ref5 = yield (0, _globPromise2.default)(filePattern),
              _ref6 = _slicedToArray(_ref5, 1);

          const filename = _ref6[0];

          if (!filename) {
            throw new Error(`ERR! ${name}.html was not found`);
          }
          const content = yield _fsExtra2.default.readFile(filename, 'utf-8');
          const result = (0, _grayMatter2.default)(content, {
            language: 'toml',
            engines: {
              toml: {
                parse: _toml2.default.parse.bind(_toml2.default)
              }
            }
          });
          const parsed = _path2.default.parse(filename);
          parsed.base = parsed.base.replace(/^\d+[.:|]/, '');
          result.filename = _path2.default.format(parsed);
          result.content = _jsBeautify2.default.html(result.content, { indent_size: 2 });

          return new _section2.default(name, result);
        });

        return function (_x4) {
          return _ref4.apply(this, arguments);
        };
      })());
    })();
  }

  prepare() {
    var _this5 = this;

    return _asyncToGenerator(function* () {
      yield _this5._reset();

      if (_this5.opts.name === '') {
        const pkgDirname = yield (0, _pkgDir2.default)(process.cwd());
        try {
          const pkg = yield _fsExtra2.default.readJson(_path2.default.join(pkgDirname, 'package.json'));
          _this5.opts.name = pkg.name;
        } catch (_) {
          // default
          _this5.opts.name = 'Yosuga';
        }
      }

      if (_this5.opts.base === undefined) {
        _this5.opts.base = yield (0, _pkgDir2.default)(process.cwd());
      }

      let targets = yield _this5._getTargets();
      targets = (0, _lodash4.default)([_this5.opts.main, ...targets]);
      const targetContents = yield _this5._getTargetContents(_compiler2.default, targets);
      const validKeys = Object.keys(targetContents[_this5.opts.main]);

      if (validKeys.length === 0) {
        throw new Error('ERR! There is no valid item');
      }

      _this5.sections = yield _this5._getSections(validKeys);

      _this5.sections.forEach(function (section) {
        section.items = targets.map(function (target) {
          if (target === _this5.opts.main) {
            section.css = targetContents[target][section.name].comparison.css;
          }

          if (targetContents[target][section.name] === undefined) {
            return undefined;
          }

          return {
            target,
            code: targetContents[target][section.name].code,
            altCode: targetContents[target][section.name].altCode
          };
        }).filter(function (target) {
          return target;
        });
      });
    })();
  }

  _exportData() {
    return this.sections.map(section => section.export());
  }

  _exportOpts() {
    return {
      icon: this.opts.icon,
      title: this.opts.name,
      style: this.opts.style
    };
  }

  _copyIconIfExists() {
    var _this6 = this;

    return _asyncToGenerator(function* () {
      if (_this6.opts.icon) {
        const iconname = _path2.default.join(_this6.opts.base, _this6.opts.icon);
        if (yield _fsExtra2.default.pathExists(iconname)) {
          yield _fsExtra2.default.copy(iconname, _path2.default.join(__dirname, '../lib/view/static/', _this6.opts.icon));
        }
      }
    })();
  }

  serve() {
    var _this7 = this;

    return _asyncToGenerator(function* () {
      const data = _this7._exportData();
      const opts = _this7._exportOpts();
      try {
        yield _fsExtra2.default.ensureDir(_this7._filepath.lib);
        yield _fsExtra2.default.writeFile(_this7._filepath.data, JSON.stringify(data));
        yield _fsExtra2.default.writeFile(_this7._filepath.opts, JSON.stringify(opts));
        yield _this7._copyIconIfExists();
      } catch (err) {
        console.log(err);
      }

      if (_this7._served) {
        return;
      }

      const matches = Object.values(_this7.opts.dirs).map(function (dir) {
        // $FlowFixMe
        return _path2.default.join(_this7.opts.base, dir, '**/*.+(css|sass|scss|less|styl)');
      });

      console.log(_chalk2.default.gray('watching...'));
      matches.forEach(function (match) {
        console.log(' - ' + match);
      });
      console.log();

      const nuxt = yield _this7.view.build();

      _this7.server = new _server2.default({
        port: _this7.opts.port,
        files: [{
          match: matches,
          fn: (() => {
            var _ref7 = _asyncToGenerator(function* () {
              yield _this7.prepare();
              yield _this7.serve();
            });

            return function fn() {
              return _ref7.apply(this, arguments);
            };
          })()
        }],
        middleware: [(() => {
          var _ref8 = _asyncToGenerator(function* (req, res, next) {
            yield nuxt.render(req, res);
            setTimeout(function () {
              next();
            }, 1000);
          });

          return function (_x5, _x6, _x7) {
            return _ref8.apply(this, arguments);
          };
        })()]
      });

      _this7._served = true;
      setTimeout(function () {
        _this7.view.setRoutes(data);
        _this7.server.serve();
      }, 3000);
    })();
  }

  generate(base) {
    var _this8 = this;

    return _asyncToGenerator(function* () {
      yield (0, _aru2.default)('dataFile', _fsExtra2.default.access(_this8._filepath.lib, _fsExtra2.default.constants.F_OK));
      yield _aru2.default.left('dataFile', _asyncToGenerator(function* () {
        yield _fsExtra2.default.mkdir(_this8._filepath.lib);
      }));

      const data = _this8._exportData();
      const opts = _this8._exportOpts();
      yield _fsExtra2.default.writeFile(_this8._filepath.data, JSON.stringify(data));
      yield _fsExtra2.default.writeFile(_this8._filepath.opts, JSON.stringify(opts));
      yield _this8._copyIconIfExists();

      _this8.view.setTitle(_this8.opts.name);
      if (base !== undefined) {
        _this8.view.setBase(base);
      }

      try {
        yield _fsExtra2.default.access(_this8._filepath.data, _fsExtra2.default.constants.F_OK);
        const rawData = yield _fsExtra2.default.readFile(_this8._filepath.data, 'utf-8');
        const data = JSON.parse(rawData);
        _this8.view.setRoutes(data);
        yield _this8.view.generate();
      } catch (err) {
        console.log(err);
      }
    })();
  }
}, _class2.defaultOpts = {
  name: '',
  port: 3333,
  main: 'css',
  dirs: {
    yosuga: 'yosuga',
    css: 'css',
    postcss: 'postcss',
    sass: 'sass',
    less: 'less',
    stylus: 'stylus'
  },
  style: {
    fontSize: '14px',
    accentColor: '#cb1b45'
  }
}, _temp), (_applyDecoratedDescriptor(_class, 'defaultOpts', [_coreDecorators.readonly], (_init = Object.getOwnPropertyDescriptor(_class, 'defaultOpts'), _init = _init ? _init.value : undefined, {
  enumerable: true,
  configurable: true,
  writable: true,
  initializer: function initializer() {
    return _init;
  }
}), _class)), _class);
exports.default = Yosuga;
module.exports = exports['default'];