'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

var _marked = require('marked');

var _marked2 = _interopRequireDefault(_marked);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Section = class Section {

  constructor(name, data) {
    this.name = name;
    this.data = data.data;
    this.html = data.content;
    this.css = '';
    this.items = [];
  }

  get title() {
    return this.data.title;
  }

  get description() {
    return (0, _lodash2.default)(this.data, 'description', undefined);
  }

  get style() {
    return {
      height: (0, _lodash2.default)(this.data, 'style.height', '70vh')
    };
  }

  export() {
    return {
      name: this.name,
      title: this.title,
      description: this.description ? (0, _marked2.default)(this.description) : undefined,
      style: this.style,
      html: this.html,
      css: this.css,
      items: this.items
    };
  }
};
exports.default = Section;
module.exports = exports['default'];