'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _desc, _value, _class, _init, _class2, _temp;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _nuxt = require('nuxt');

var _coreDecorators = require('core-decorators');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

let View = (_class = (_temp = _class2 = class View {

  /**
   *
   * @param  {[type]} opts [description]
   * @return {[type]}      [description]
   */
  constructor(opts) {
    this.config = {};
    this.config.head = this._extends('head', opts);
    this.config.cache = this._extends('cache', opts);
    this.config.env = this._extends('env', opts);
    this.config.loading = this._extends('loading', opts);
    this.config.generate = this._extends('generate', opts);
    this.config.router = this._extends('router', opts);
    this.config.build = this._extends('build', opts);
    this.config.build.vender = ['resize-observer-polyfill', 'clipboard', 'lodash.throttle', 'lodash.debounce', 'highlight.js/lib/highlight', 'highlight.js/lib/languages/xml', 'highlight.js/lib/languages/css', 'highlight.js/lib/languages/scss', 'highlight.js/lib/languages/less', 'highlight.js/lib/languages/stylus', 'highlight.js/styles/atom-one-dark.css', '~/lib/data', '~/lib/opts'];
    this.config.transition = this._extends('transition', opts);
    this.config.performance = this._extends('performance', opts);
    this.config.watchers = this._extends('watchers', opts);

    this.config.rootDir = opts.rootDir || View.defaultOpts.rootDir;
    this.config.srcDir = opts.srcDir || _path2.default.join(__dirname, '../lib/view/');
    this.config.dev = (() => {
      if (typeof opts.dev === 'undefined' || opts.dev === null) {
        return process.env.NODE_ENV !== 'production';
      }
      return opts.dev;
    })();
    this.config.css = [...(opts.css || []), '~static/base.css'];
    this.config.plugins = opts.plugins || [];
    this.config.modules = View.defaultOpts.modules;
    this.config.workbox = View.defaultOpts.workbox;
    this.config.manifest = View.defaultOpts.manifest;
  }

  setTitle(title) {
    this.config.head.title = title;
    this.config.manifest.name = title;
  }

  setRoutes(sections) {
    const routes = sections.map(s => `/sections/${s.name}`);
    if (this.config.generate.routes === undefined) {
      this.config.generate = _extends({}, this.config.generate, {
        routes
      });
    } else {
      this.config.generate.routes.push(...routes);
    }
  }

  setBase(base) {
    this.config.router.base = base;
  }

  build() {
    var _this = this;

    return _asyncToGenerator(function* () {
      const nuxt = new _nuxt.Nuxt(_this.config);
      const builder = new _nuxt.Builder(nuxt);
      try {
        yield builder.build();
      } catch (err) {
        console.log(err);
      }
      return nuxt;
    })();
  }

  generate() {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      const nuxt = new _nuxt.Nuxt(_this2.config);
      const builder = new _nuxt.Builder(nuxt);
      const generator = new _nuxt.Generator(nuxt, builder);
      try {
        yield generator.generate();
        // await generator.generate({
        //   routes: sections.map(s => `/sections/${s.name}`),
        // });
      } catch (err) {
        console.log(err);
      }
      return nuxt;
    })();
  }

  _extends(prop, opts) {
    return Object.assign({}, View.defaultOpts[prop] || {}, opts[prop] || {});
  }
}, _class2.defaultOpts = {
  head: {
    title: 'Yosuga',
    meta: [{ charset: 'utf-8' }, { name: 'viewport', content: 'width=device-width, initial-scale=1' }, { hid: 'description', name: 'description', content: 'CSS Document' }, { name: 'theme-color', content: '#f8f8f8' }],
    link: [{
      rel: 'stylesheet',
      href: '//fonts.googleapis.com/css?family=Source+Code+Pro'
    }, {
      rel: 'apple-touch-icon',
      sizes: '180x180',
      href: 'apple-touch-icon.png'
    }, {
      rel: 'icon',
      type: 'image/png',
      sizes: '32x32',
      href: 'favicon-32x32.png'
    }, {
      rel: 'icon',
      type: 'image/png',
      sizes: '16x16',
      href: 'favicon-16x16.png'
    }, {
      rel: 'mask-icon',
      href: 'safari-pinned-tab.svg',
      color: '#5bbad5'
    }]
  },
  cache: {
    max: 1000,
    maxAge: 900000
  },
  loading: { color: '#3B8070' },
  dev: process.env.NODE_ENV !== 'production',
  generate: {
    dir: 'dist'
  },
  rootDir: process.cwd(),
  router: {
    base: '/'
  },
  modules: ['@nuxtjs/pwa'],
  workbox: {
    // dev: false,
    dev: process.env.NODE_ENV !== 'production',
    runtimeCaching: [{
      urlPattern: 'https://fonts.googleapis.com/css?family=.*',
      handler: 'cacheFirst',
      method: 'GET'
    }]
  },
  manifest: {
    name: 'My Awesome App',
    icons: [{
      src: '/android-chrome-192x192.png',
      sizes: '192x192',
      type: 'image/png'
    }, {
      src: '/android-chrome-384x384.png',
      sizes: '384x384',
      type: 'image/png'
    }],
    theme_color: '#f8f8f8',
    background_color: '#f8f8f8',
    display: 'standalone'
  }
}, _temp), (_applyDecoratedDescriptor(_class, 'defaultOpts', [_coreDecorators.readonly], (_init = Object.getOwnPropertyDescriptor(_class, 'defaultOpts'), _init = _init ? _init.value : undefined, {
  enumerable: true,
  configurable: true,
  writable: true,
  initializer: function initializer() {
    return _init;
  }
}), _class)), _class);
exports.default = View;
module.exports = exports['default'];